#define INT1

#define INTURRUPT_SERVICE_ROUTINE_1		c_int1

#define MOVE_RIGHT						FORCED_HIGH
#define MOVE_LEFT						FORCED_LOW

#include <..\include\240.h>
#include <..\include\eslab240.h>
#include <..\include\using.h>

/*   */
int iGetData=0;

void INTURRUPT_SERVICE_ROUTINE_1()
{
	DISABLE_ALL_INT();

	if(*SYSIVR == 0x0006)
	{
		iGetData = *SCI_RX_BUF;

		if(iGetData>127) /* (-) */
		{
			iGetData -= 128;
			*CMPR1 = iGetData;
			*ACTR = (ACTIVE_LOW << FCMP1_OUTPUT_PIN) |	/* PWM1/CMP1 Compare Output Active low .	*/
					(MOVE_LEFT << FCMP2_OUTPUT_PIN);	/* PWM2/CMP2 Compare Output Forced HIGH .	*/
		} else {
			*CMPR1 = iGetData;
			*ACTR = (ACTIVE_LOW << FCMP1_OUTPUT_PIN) |	/* PWM1/CMP1 Compare Output Active low .	*/
					(MOVE_RIGHT << FCMP2_OUTPUT_PIN);	/* PWM2/CMP2 Compare Output Forced HIGH .	*/
		}
	}

	ENABLE_ALL_INT();
}

void SettingSCI()
{
	*SCI_CCNTL = SCI_STOP_BITS_1 |				/*  Ʈ 1				*/
				 SCI_CHAR_LENGTH_8 |			/*   8Ʈ			*/
				 SCI_PARITY_DISABLE |			/* иƼ Ʈ  	*/
				 SCI_IDLE_MODE |				/* IDLE  				*/
				 SCI_ENABLE;					/* SCI  Ȱȭ				*/

	*SCI_CNTL2 = SCI_RX_INT_ENABLE;				/* SCI RX ͷƮ Ȱȭ		*/

	*SCI_HBAUD = 0;								/* SYSCLK : 10Mhz, Baud = 19200 */
	*SCI_LBAUD = 64;

	*SCI_PORT_C2 = SCI_TXD_TRANSMIT |			/* Ʈ TxD  		*/
				   SCI_RXD_RECEIVE;				/* Ʈ RxD  		*/

	*SCI_CNTL1 = SCI_INTERNAL_CLOCK_ENABLE |	/*  SYSCLK 				*/
				 SCI_TX_ENABLE |				/* TX Ȱȭ					*/
				 SCI_RX_ENABLE |				/* RX Ȱȭ					*/
				 SCI_SW_RESET_DISABLE;			/* SCI  Ų.		*/
}

void main()  
{
	/* DSP TMS320F240 ʱȭ Ų. */
	InitController();

	/* ͷƮ  */
	*IFR = INTx_INIT_FLAG;
	*IMR = INT1_UNMASK;
	ENABLE_ALL_INT();

	/* Setting SCI Module */
	SettingSCI();

	/* Setting ADC Control Register 2.	*/
	*ADC_CNTL2 = ADC_PS_12;		/* 6.6us > 6.1us > 5.5us	*/

	/* Setting ADC Control Register 1.	*/
	*ADC_CNTL1 = ADC_EMU_FREE |			/* ADC Emulator   ʵ Ѵ.	*/
				 ENABLE_ADC1 |			/* ADC1 Ұ ˸.					*/
				 ADC_INT_FLAG |			/* ͷƮ ÷׸ Ŭ Ų.				*/
				 ADC1_CHANNEL_3 |		/* ADC Channel 3 Ѵ.					*/
				 ADC_CONTINUOUS_MODE |	/* ADC Continuous Conversion Mode Ѵ.	*/
				 ADC_START_CONVERSION;	/* A/D  Ѵ.						*/

	/* Timer 1 Period Register Ѵ.	*/
	*T1PER = 127;

	/* Compare Ͱ õɶ  ī ϱ	*/
	/* Ͽ Ѵ.										*/
	*T1CNT = 0xff00;

	/* Timer 1 Control Register  Ѵ.	*/
	*T1CON = EMULATION_FREE |					/* Timer  Emulator   ʵ Ѵ.		*/
			 CONTINUOUS_UPDOWN_COUNTING_MODE |	/* Timer 1 Continuous Up/Down Counting Mode Ѵ.	*/
			 CLOCK_PS_1 |						/* Input Clock  ָ  ʴ´.					*/
			 TCLKS_INTERNAL;					/* Input Clock Source Internal Ѵ.				*/

	/* Full Compare Register ʱȭ Ѵ.	*/
	*CMPR1 = iGetData;

	/* Full Compare Action Control Register  Ѵ.	*/
	*ACTR = (ACTIVE_LOW << FCMP1_OUTPUT_PIN) |	/* PWM1/CMP1 Compare Output Active low .	*/
			(MOVE_RIGHT << FCMP2_OUTPUT_PIN);	/* PWM2/CMP2 Compare Output Forced HIGH .	*/

	/* TI PWM mode Full Compare ۽ų  COMCON[15] Ʈ */
	/* set Ű Ͱ set Ų  COMCON ͸ ϱ⸦ */
	/* õϰ ִ.														*/

	/* Compare Control Register  Ѵ.	*/
	*COMCON = FCLD_T1CNT0 |				/* T1CNT = 0϶ CMPRx ͸ Reload Ѵ.	*/
			  FACTRLD_T1CNT0 |			/* T1CNT = 0϶ ACTR ͸ Reload Ѵ.	*/
			  FCO_ENABLE |				/* Full Compare Output Enable					*/
			  (PWM_MODE << FCMP_MODE1);	/* unit 1 PWM mode Ѵ.				*/

	/* Compare Control Register  Ѵ.	*/
	*COMCON = GLOBAL_COMPARE_ENABLE |	/* ü Compare  Enable Ų.			*/
			  FCLD_T1CNT0 |				/* T1CNT = 0϶ CMPRx ͸ Reload Ѵ.	*/
			  FACTRLD_T1CNT0 |			/* T1CNT = 0϶ ACTR ͸ Reload Ѵ.	*/
			  FCO_ENABLE |				/* Full Compare Output Enable					*/
			  (PWM_MODE << FCMP_MODE1);	/* unit 1 PWM mode Ѵ.				*/

	/* Timer 1 Enable Ų. */
	TMR1_ENABLE();

	while(1)
	{
		/* LED  ġ ǥѴ.	*/
		PutLed(iGetData);
	}
}