#include <..\include\240.h>
#include <..\include\eslab240.h>
#include <..\include\using.h>

void main()  
{
	unsigned int ad1_result, ad2_result;
	unsigned int e, u, dir;
	float K_p=2.3f;

	/* DSP TMS320F240 ʱȭ Ų. */
	InitController();

	/* Setting ADC Control Register 2.	*/
	*ADC_CNTL2 = ADC_PS_12;		/* 6.6us > 6.1us > 5.5us	*/

	/* Setting ADC Control Register 1.	*/
	*ADC_CNTL1 = ADC_EMU_FREE |			/* ADC Emulator   ʵ Ѵ.	*/
				 ENABLE_ADC1 |			/* ADC1   ˸.					*/
				 ENABLE_ADC2 |			/* ADC2   ˸.					*/
				 ADC_INT_FLAG |			/* ͷƮ ÷׸ Ŭ Ų.				*/
				 ADC1_CHANNEL_3 |		/* ADC Channel 3 Ѵ.					*/
				 ADC2_CHANNEL_10 |		/* ADC Channel 10 Ѵ.					*/
				 ADC_CONTINUOUS_MODE |	/* ADC Continuous Conversion Mode Ѵ.	*/
				 ADC_START_CONVERSION;	/* A/D  Ѵ.						*/

	/* Timer 1 Period Register Ѵ.	*/
	*T1PER = 1000;

	/* Timer 1 Control Register  Ѵ.	*/
	*T1CON = EMULATION_FREE |					/* Timer  Emulator   ʵ Ѵ.	*/
			 SINGLE_UPDOWN_COUNTING_MODE |		/* Timer 1 Single Up/Down Counting Mode Ѵ.	*/
			 CLOCK_PS_8 |						/* Input Clock  8 ָ Ѵ.					*/
			 TCLKS_INTERNAL;					/* Input Clock Source Internal Ѵ.			*/

	/* TI PWM mode Full Compare ۽ų  COMCON[15] Ʈ */
	/* set Ű Ͱ set Ų  COMCON ͸ ϱ⸦ */
	/* õϰ ִ.														*/

	/* Compare Control Register  Ѵ.	*/
	*COMCON = FCLD_IMMEDIATELY |		/* CMPRx ͸  Reload Ѵ.			*/
			  FACTRLD_IMMEDIATELY |		/* ACTR ͸  Reload Ѵ.			*/
			  FCO_ENABLE |				/* Full Compare Output Enable					*/
			  (PWM_MODE << FCMP_MODE1);	/* unit 1 PWM mode Ѵ.				*/

	/* Compare Control Register  Ѵ.	*/
	*COMCON = GLOBAL_COMPARE_ENABLE |	/* ü Compare  Enable Ų.			*/
			  FCLD_IMMEDIATELY |		/* CMPRx ͸  Reload Ѵ.			*/
			  FACTRLD_IMMEDIATELY |		/* ACTR ͸  Reload Ѵ.			*/
			  FCO_ENABLE |				/* Full Compare Output Enable					*/
			  (PWM_MODE << FCMP_MODE1);	/* unit 1 PWM mode Ѵ.				*/

	while(1)
	{
		/*  ֱⰡ ٸ ο Compare  Ѵ. */
		if(GET_TMR1_STATUS() == TMR_DISABLE) {

			/* Full Compare  Ų. */
			*COMCON &= 0x7fff;

			/* ADC2 FIFO Ͽ Ͱ ö ٸ.	*/
			while(!GET_FIFO2_STATUS());

			/* Ͱ FIFO  о´.	*/
			ad2_result = *ADC_FIFO2;

			/* Ͱ  15° Ʈ ϵǾ Ƿ Ʒ  .	*/
			ad2_result >>= 6;

			/* ADC1 FIFO Ͽ Ͱ ö ٸ.	*/
			while(!GET_FIFO1_STATUS());

			/* Ͱ FIFO  о´.	*/
			ad1_result = *ADC_FIFO1;

			/* Ͱ  15° Ʈ ϵǾ Ƿ Ʒ  .	*/
			ad1_result >>= 6;

			/*    Ѵ. */
			if(ad1_result > ad2_result) {
				e = ad1_result - ad2_result;

				/* <-- */
				dir = FORCED_HIGH;
			} else if(ad1_result < ad2_result){
				e = ad2_result - ad1_result;

				/* --> */
				dir = FORCED_LOW;
			}

			/*  u ´. */
			u = (unsigned int)((float)e * K_p);

			/* Ͱ ȸϱ  ּ Compare . */
			u += 170;	 /* 170 */

			/* u ֱⰪ 999  ʵ Ѵ. */
			if(u >= 1000)	u = 999;
			/* u Ͱ ȸ   ̸ ּҰ . */
			if(u <= 220) u = 1;

			/* Full Compare Register ʱȭ Ѵ.	*/
			*CMPR1 = (1000 - u);

			/* Full Compare Action Control Register  Ѵ.	*/
			*ACTR = (ACTIVE_HIGH << FCMP1_OUTPUT_PIN) |	/* PWM1/CMP1 Compare Output Active low .	*/
					(dir << FCMP2_OUTPUT_PIN);			/* PWM2/CMP2 Compare Output Forced HIGH .	*/

			/* Full Compare  Enable Ų. */
			*COMCON |= 0x8000;

			/* GP Timer 1 Enable Ų. */
			TMR1_ENABLE();
		}

		/* LED  ġ ǥѴ.	*/
		PutLed(u);
	}
}