#include <..\include\240.h>
#include <..\include\eslab240.h>
#include <..\include\using.h>

#define TIMER_PERIOD		1000

#define DIR_RIGHT			FORCED_LOW
#define DIR_LEFT			FORCED_HIGH

#define ERROR_RANGE			10

#define K_p					0.67f	/* 0.4 */
#define K_i					0.1f	/* 0.71 */

void main()  
{
	unsigned int ad1_result, ad2_result;
	unsigned int dir, pwm_output;
	unsigned int e, prev_e=0, result_u;
	float u, prev_u=.0f;

	/* DSP TMS320F240 ʱȭ Ų. */
	InitController();

	/* Setting ADC Control Register 2.	*/
	*ADC_CNTL2 = ADC_PS_12;		/* 6.6us > 6.1us > 5.5us	*/

	/* Setting ADC Control Register 1.	*/
	*ADC_CNTL1 = ADC_EMU_FREE |			/* ADC Emulator   ʵ Ѵ.	*/
				 ENABLE_ADC1 |			/* ADC1   ˸.					*/
				 ENABLE_ADC2 |			/* ADC2   ˸.					*/
				 ADC_INT_FLAG |			/* ͷƮ ÷׸ Ŭ Ų.				*/
				 ADC1_CHANNEL_3 |		/* ADC Channel 3 Ѵ.					*/
				 ADC2_CHANNEL_10 |		/* ADC Channel 10 Ѵ.					*/
				 ADC_CONTINUOUS_MODE |	/* ADC Continuous Conversion Mode Ѵ.	*/
				 ADC_START_CONVERSION;	/* A/D  Ѵ.						*/

	/* Timer 1 Period Register Ѵ.	*/
	*T1PER = TIMER_PERIOD;

	/* Compare Ͱ õɶ  ī ϱ	*/
	/* Ͽ Ѵ.										*/
	*T1CNT = 0xff00;

	/* Timer 1 Control Register  Ѵ.	*/
	*T1CON = EMULATION_FREE |					/* Timer  Emulator   ʵ Ѵ.		*/
			 CONTINUOUS_UPDOWN_COUNTING_MODE |	/* Timer 1 Continuous Up/Down Counting Mode Ѵ.	*/
			 CLOCK_PS_1 |						/* Input Clock  ָ  ʴ´.					*/
			 TCLKS_INTERNAL;					/* Input Clock Source Internal Ѵ.				*/

	/* Full Compare Register ʱȭ Ѵ.	*/
	*CMPR1 = 0;

	/* TI PWM mode Full Compare ۽ų  COMCON[15] Ʈ */
	/* set Ű Ͱ set Ų  COMCON ͸ ϱ⸦ */
	/* õϰ ִ.														*/

	/* Compare Control Register  Ѵ.	*/
	*COMCON = FCLD_T1CNT0 |				/* T1CNT = 0϶ CMPRx ͸ Reload Ѵ.	*/
			  FACTRLD_T1CNT0 |			/* T1CNT = 0϶ ACTR ͸ Reload Ѵ.	*/
			  FCO_ENABLE |				/* Full Compare Output Enable					*/
			  (PWM_MODE << FCMP_MODE1);	/* unit 1 PWM mode Ѵ.				*/

	/* Compare Control Register  Ѵ.	*/
	*COMCON = GLOBAL_COMPARE_ENABLE |	/* ü Compare  Enable Ų.			*/
			  FCLD_T1CNT0 |				/* T1CNT = 0϶ CMPRx ͸ Reload Ѵ.	*/
			  FACTRLD_T1CNT0 |			/* T1CNT = 0϶ ACTR ͸ Reload Ѵ.	*/
			  FCO_ENABLE |				/* Full Compare Output Enable					*/
			  (PWM_MODE << FCMP_MODE1);	/* unit 1 PWM mode Ѵ.				*/

	/* Timer 1 Enable Ų. */
	TMR1_ENABLE();

	while(1)
	{
		/* ADC2 FIFO Ͽ Ͱ ö ٸ.	*/
		while(!GET_FIFO2_STATUS());

		/* Ͱ FIFO  о´.	*/
		ad2_result = *ADC_FIFO2;

		/* Ͱ  15° Ʈ ϵǾ Ƿ Ʒ  .	*/
		ad2_result >>= 6;

		/* ADC1 FIFO Ͽ Ͱ ö ٸ.	*/
		while(!GET_FIFO1_STATUS());

		/* Ͱ FIFO  о´.	*/
		ad1_result = *ADC_FIFO1;

		/* Ͱ  15° Ʈ ϵǾ Ƿ Ʒ  .	*/
		ad1_result >>= 6;

		/* A/D ȯ ػ󵵸 5000 δ. */
		ad1_result = (unsigned int)((float)ad1_result / 1023.0f * 5.0f * 1000.0f);
		ad2_result = (unsigned int)((float)ad2_result / 1023.0f * 5.0f * 1000.0f);

		/*    Ѵ. */
		if(ad1_result > ad2_result) {
			e = ad1_result - ad2_result;

			dir = DIR_LEFT;
		} else if(ad1_result < ad2_result){
			e = ad2_result - ad1_result;

			dir = DIR_RIGHT;
		}

		/*  u ´. */
		u = (float)( ((K_p + (K_i * 0.0002f))*(float)e) + prev_u - (K_p * (float)prev_e));

		/*    Ѵ. */
		prev_u = u;
		prev_e = e;

		/* e   Ѵ. */
		if(e < ERROR_RANGE) {
			prev_e = 0;
			prev_u = 0.0f;
		}

		/*  u  ȯѴ. */
		result_u = (unsigned int)u;

		/* u  ֱⰪ  ʵ Ѵ. */
		if(result_u >= TIMER_PERIOD) {
			result_u = TIMER_PERIOD;
			pwm_output = FORCED_HIGH;
		}
		else
			pwm_output = ACTIVE_HIGH;

		/* LED  ġ ǥѴ.	*/
		PutLed(result_u);

		/* Full Compare Register ʱȭ Ѵ.	*/
		*CMPR1 = (TIMER_PERIOD - result_u);

		/* Full Compare Action Control Register  Ѵ.	*/
		*ACTR = (pwm_output << FCMP1_OUTPUT_PIN) |	/* PWM1/CMP1 Compare Output Active High .	*/
				(dir << FCMP2_OUTPUT_PIN);			/* PWM2/CMP2 Compare Output Forced HIGH .	*/
	}
}