/*
Title 		: IELABOS.C
Abstract 	: Serial communication starting program for 240 using polling
Author  	: Park, Tae-Sik , Lee, Chun-ho
Date 		: 1999, 11
IeLab. Korea University  Seoul, 136-701  Korea
All rights reservedMAKE Version 5.1  Copyright (c) 1987, 1998 Borland International
/**/

#define INT1
#include <c:\ielab240\include\240.h>
#include <c:\ielab240\include\ielab240.h>


#define IDM_PROGRAM     0x10        /* α׷ ٿε ޽ */
#define IDM_PLAY        0x11        /* α׷  ޽ */
#define IDM_STOP        0x12        /* α׷  ޽ */
#define IDM_DATA        0x13        /*  ε ޽ */
#define NO_MESSAGE      0x0     	/* ޽  */

typedef unsigned char	byte;
typedef	unsigned int	word;

ioport unsigned port8011;
#define Led port8011

ioport unsigned port8070;
#define ReBoot	port8070

ioport unsigned portffff;
#define WSGR portffff

char GetByteSer();
word GetWordSer(void);
void PutWordSer(word wData);
void PutByteSer(char TxData);
void Init_SCI();
void out(word port,word data);
void PutWordHEX(word data);
void c_SCI_Receive_Int();

word TotalLength;

void Delay(long count)
{
	long d;
	for(d=0; d<count; d++)
	{
		asm("nop");
	}
}

void c_int1()
{
	Disable_INT();
	if(*SYSIVR == 0x0006) c_SCI_Receive_Int(); /**/
	Enable_INT();
}

void c_SCI_Receive_Int()
{
 		switch(*SCI_RX_BUF)
  		{
  			case IDM_PROGRAM: 
  				ReceiveProgram(); 
 				break;
  			
  			case IDM_PLAY:		
  				ReBoot = 1;		
  				break;
			
			default:
				break;
  		}

}

void main()  
{
  	unsigned int i=0,j;
  	word	Temp;
  	word	error;
  	word   *pAddr;
	char    data;
	char	message;

	Disable_INT();
	Clear_CNF();
	Clear_OVM();
	Clear_SXM();
	Disable_WD();

	/* 20MHz  */	
	
	*CKCR1 = 0x0066;
	*CKCR0 = 0X0041;

	
	/* 40MHz  */
/*	*CKCR1 = CKINF_20 | PLL_MUL_RATIO_2;
	*CKCR0 = CLKIN | PLLPS | PLL_ENA;	
	while( !(*CKCR0 & PLL_LOCK) );	
/**/
	
	*SYSCR = 0x40c0;
	WSGR = ISWS | PSWS | DSWS;
	
  	Init_SCI();

	Clear_XF();	
	
	*IFR = 0x0000;
	*IMR = 0x0001;
	Enable_INT();
	
/* ޸  б Ȯ */	
	error = 0;
	for(i=0;i<0x8000;i++) {
		pAddr = (word *)(i+0x8000);
/*		Led = i+0x8000;	*/
		Temp = *pAddr;
		*pAddr = 0;
		if (*pAddr != 0) {
			error = 0x1111;
			break;
		}
		*pAddr = 0xffff;
		if (*pAddr != 0xffff) {
			error = 0x1111;
			break;
		}
		*pAddr = Temp;
		if (*pAddr != Temp) {
			error = 0x1111;
			break;
		}
	}
	
	if (error != 0)
	{
		for(i=0;i<10;i++) {
			Led = error;
			Delay(100000);	
			Led = 0xffff;
			Delay(100000);
		}
	}
		
	
	while(1)
	{
		Led = 0xfff0;
		Delay(50000);
		Led = 0xff0f;
		Delay(50000);
		Led = 0xf0ff;
		Delay(50000);
		Led = 0x0fff;
		Delay(50000);
		Led = 0xf0ff;
		Delay(50000);
		Led = 0xff0f;
		Delay(50000);

 	}
	Set_XF();
}

void ReceiveProgram(void)          /* α׷ ޱ */
{
    word   LineLength, i;
    word   *pLineAddr;
    word   data;
    word   error=0;

    /* HEX = LineLength : LineAddress : LineCode */
	
    TotalLength = 0;
    
    while( 1 ) 
    {
    	LineLength = GetByteSer();
    
    	if (LineLength == 0) break;
	
		pLineAddr = (word *)(GetWordSer() + 0x8000);
	
		for(i=0; i<(LineLength/2); i++) 
		{
			data = GetWordSer();
			Led = data;
			*pLineAddr = data;
			if (*pLineAddr != data)
				error = 0x1111;
			pLineAddr++;
		}
		TotalLength += LineLength; /**/
    }
    Led = error;
    Delay(50000);
    Delay(50000);
}

			

void Init_SCI()
{
	/*
	0000 0000 0001 0111
	7:STOP BIT            = 0 = one stop bit
	6:PARITY              = 0 = Odd parity if SCICCR.5(Parity enable bit)
	                                         is enabled
	5:PARITY ENA          = 0 = Parity disable
	4:SCI ENA             = 1 = SCI is enabled
	3:ADDR/IDLE MODE      = 0 = IDLE MODE
	2,1,0:CHAR LENG       = 1 1 1 = 8bit Character length
	/**/
	*SCI_CCNTL = 0x0017;

	
	/*
	7(R):TXRDY            = 0 = Full   (Flag)
	6(R):TX EMPTY         = 0 = Loaded (Flag)
	1(RW):RX/BK INT ENA   = 1 = Enabled
	0(RW):TX INT ENA      = 0 = Enabled 
	/**/
	*SCI_CNTL2 = 0x0002; 



	/*
                      SYSCLK 
      BRP = ----------------------------  -  1
             SCI asynchronous baud * 8  
	/**/
	*SCI_HBAUD = 0x0000;
	*SCI_LBAUD = 64;

	/*
	0000 0000 0010 0010
	7(R):SCITXD DATA IN   = 0 = Pin SCITXD value as 0
	6(RW):SCITXD DATA OUT =   = contains the data to be output on the SCITXD 
                                If the pin is GP digital IO output pin
	5(RW):SCITXD FUNCTION = 1 = SCITXD is a transmit pin
	4(RW):SCITXD DATA DIR = 0 = SCITXD is a digital input pin
	3(R):SCIRXD DATA IN   =   = Contains the current value of pin SCIRXD
	2(RW):SCIRXD DATA OUT = 0 = Value to be ooutput on pin SCIRXD
	1(RW):SCIRXD FUNCTION = 1 = SCIRXD is a the SCI receive pin
	0(RW):SCIRXD DATA DIR = 0 = SCIRXD is a digital input pin
	/**/
	*SCI_PORT_C2 = 0x0022;
	
	/*
	0000 0000 0001 0011
	6(RW):RX ERR INT ENA  = 0 = disable
	5(RW):SW RESET        = 1 = SCI Reset
	4(RW):CLOCK ENA       = 1 = Enable Internal Clock
	3(RS):TXWAKE          = 0 = Transmit Feature is not selected
	2(RW):SLEEP           = 0 = Sleep mode is disabled
	1(RW):TXENA           = 1 = Transmitter is enabled
	0(RW):RXENA           = 1 = Receiver is enabled
	/**/
	*SCI_CNTL1 = 0x0033;
	
	/*
	7:RESERVED
	6(RW):SCITX PRIORITY  = 0 = Interrupts are high-priority requests
	5(RW):SCIRX PRIORITY  = 0 = Interrupts are high-priority requests
	4(RW):SCI ESPEN       = 0 = SCI emulator suspend enable
	3-0:RESERVED
	/**/
	/* 
	*SCI_PRI = 0x0000;
	/**/
}

char GetByteSer()
{
	while((*SCI_RX_STAT & 0x40)==0);
	return *SCI_RX_BUF;
}

void PutByteSer(char TxData)
{
	while(!(*SCI_CNTL2 & 0x80)); 
	*SCI_TX_BUF = TxData;
}

word GetWordSer(void)
{
	word wData=0;

	wData = GetByteSer();       /*  Ʈ */
	wData = wData<<8;
	wData = wData + GetByteSer();      /*  Ʈ */

	return wData;
}


void PutWordSer(word wData)
{
	word wHigh=0;

	wHigh = wData >> 8;
	PutByteSer(wHigh);          /*  Ʈ */
	PutByteSer(wData);          /*  Ʈ */
}

