
/*****************************************************************************************/
/*											 */	
/* Description : TMS320F240 Header file with all Peripheral Register declarations	 */	
/*		 plus other useful defines.						 */	
/*											 */	
/*****************************************************************************************/

#ifndef		__REG_PTR_H
#define		__REG_PTR_H

/*--------------------------------------------------------------*/
/* On Chip Periperal Register Definitions (DATA SPACE)		*/
/*--------------------------------------------------------------*/

/* C2xx Core Registers */

extern	volatile unsigned int * IMR = (volatile unsigned int *) ADDR_IMR;
extern	volatile unsigned int * GREG = (volatile unsigned int *) ADDR_GREG;
extern	volatile unsigned int * IFR = (volatile unsigned int *) ADDR_IFR;
extern	volatile unsigned int * ABRPT = (volatile unsigned int *) ADDR_ABRPT;

/* System Module Registers */

extern	volatile unsigned int * SYSCR = (volatile unsigned int *) ADDR_SYSCR;
extern	volatile unsigned int * SYSSR = (volatile unsigned int *) ADDR_SYSSR;
extern	volatile unsigned int * DIN = (volatile unsigned int *) ADDR_DIN;
extern	volatile unsigned int * SYSIVR = (volatile unsigned int *) ADDR_SYSIVR;
extern	volatile unsigned int * XINT1_CNTL = (volatile unsigned int *) ADDR_XINT1_CNTL;
extern	volatile unsigned int * NMI_CNTL = (volatile unsigned int *) ADDR_NMI_CNTL;
extern	volatile unsigned int * XINT2_CNTL = (volatile unsigned int *) ADDR_XINT2_CNTL;
extern	volatile unsigned int * XINT3_CNTL = (volatile unsigned int *) ADDR_XINT3_CNTL;
extern	volatile unsigned int * PDPINT_CNTL = (volatile unsigned int *) ADDR_PDPINT_CNTL;

/* Digital I/O */

extern	volatile unsigned int * OPCRA = (volatile unsigned int *) ADDR_OPCRA;
extern	volatile unsigned int * OPCRB = (volatile unsigned int *) ADDR_OPCRB;
extern	volatile unsigned int * IPSRA = (volatile unsigned int *) ADDR_IPSRA;
extern	volatile unsigned int * IPSRB = (volatile unsigned int *) ADDR_IPSRB;
extern	volatile unsigned int * PADATDIR = (volatile unsigned int *) ADDR_PADATDIR;
extern	volatile unsigned int * PBDATDIR = (volatile unsigned int *) ADDR_PBDATDIR;
extern	volatile unsigned int * PCDATDIR = (volatile unsigned int *) ADDR_PCDATDIR;
extern	volatile unsigned int * PDDATDIR = (volatile unsigned int *) ADDR_PDDATDIR;

/* Watch-Dog(WD) / Real Time Int(RTI) / Phase Lock Loop(PLL) Registers */

extern	volatile unsigned int * RTI_CNTR = (volatile unsigned int *) ADDR_RTI_CNTR;
extern	volatile unsigned int * WD_CNTR = (volatile unsigned int *) ADDR_WD_CNTR;
extern	volatile unsigned int * WD_KEY = (volatile unsigned int *) ADDR_WD_KEY;
extern	volatile unsigned int * RTI_CNTL = (volatile unsigned int *) ADDR_RTI_CNTL;
extern	volatile unsigned int * WD_CNTL = (volatile unsigned int *) ADDR_WD_CNTL;
extern	volatile unsigned int * PLL_CNTL1 = (volatile unsigned int *) ADDR_PLL_CNTL1;
extern	volatile unsigned int * PLL_CNTL2 = (volatile unsigned int *) ADDR_PLL_CNTL2;

/* Analog-to-Digital Converter(ADC) registers */

extern	volatile unsigned int * ADC_CNTL1 = (volatile unsigned int *) ADDR_ADC_CNTL1;
extern	volatile unsigned int * ADC_CNTL2 = (volatile unsigned int *) ADDR_ADC_CNTL2;
extern	volatile unsigned int * ADC_FIFO1 = (volatile unsigned int *) ADDR_ADC_FIFO1;
extern	volatile unsigned int * ADC_FIFO2 = (volatile unsigned int *) ADDR_ADC_FIFO2;

/* Serial Peripheral Interface (SPI) Registers */

extern	volatile unsigned int * SPI_CCR = (volatile unsigned int *) ADDR_SPI_CCR;
extern	volatile unsigned int * SPI_CTL = (volatile unsigned int *) ADDR_SPI_CTL;
extern	volatile unsigned int * SPI_STS = (volatile unsigned int *) ADDR_SPI_STS;
extern	volatile unsigned int * SPI_BRR = (volatile unsigned int *) ADDR_SPI_BRR;
extern	volatile unsigned int * SPI_EMU = (volatile unsigned int *) ADDR_SPI_EMU;
extern	volatile unsigned int * SPI_BUF = (volatile unsigned int *) ADDR_SPI_BUF;
extern	volatile unsigned int * SPI_DAT = (volatile unsigned int *) ADDR_SPI_DAT;
extern	volatile unsigned int * SPI_PC1 = (volatile unsigned int *) ADDR_SPI_PC1;
extern	volatile unsigned int * SPI_PC2 = (volatile unsigned int *) ADDR_SPI_PC2;
extern	volatile unsigned int * SPI_PRI = (volatile unsigned int *) ADDR_SPI_PRI;

/* Serial Communications Interface (SCI) Registers */

extern	volatile unsigned int * SCI_CCNTL = (volatile unsigned int *) ADDR_SCI_CCNTL;
extern	volatile unsigned int * SCI_CNTL1 = (volatile unsigned int *) ADDR_SCI_CNTL1;
extern	volatile unsigned int * SCI_LBAUD = (volatile unsigned int *) ADDR_SCI_LBAUD;
extern	volatile unsigned int * SCI_HBAUD = (volatile unsigned int *) ADDR_SCI_HBAUD;
extern	volatile unsigned int * SCI_CNTL2 = (volatile unsigned int *) ADDR_SCI_CNTL2;
extern	volatile unsigned int * SCI_RX_STAT = (volatile unsigned int *) ADDR_SCI_RX_STAT;
extern	volatile unsigned int * SCI_RX_EMU = (volatile unsigned int *) ADDR_SCI_RX_EMU;
extern	volatile unsigned int * SCI_RX_BUF = (volatile unsigned int *) ADDR_SCI_RX_BUF;
extern	volatile unsigned int * SCI_TX_BUF = (volatile unsigned int *) ADDR_SCI_TX_BUF;
extern	volatile unsigned int * SCI_PORT_C1 = (volatile unsigned int *) ADDR_SCI_PORT_C1;
extern	volatile unsigned int * SCI_PORT_C2 = (volatile unsigned int *) ADDR_SCI_PORT_C2;
extern	volatile unsigned int * SCI_PRI = (volatile unsigned int *) ADDR_SCI_PRI;

/* Event Manager (EV) - EV Base Address = 0x7400 */

extern	volatile unsigned int * GPTCON = (volatile unsigned int *) ADDR_GPTCON;
extern	volatile unsigned int * T1CNT = (volatile unsigned int *) ADDR_T1CNT;
extern	volatile unsigned int * T1CMP = (volatile unsigned int *) ADDR_T1CMP;
extern	volatile unsigned int * T1PER = (volatile unsigned int *) ADDR_T1PER;
extern	volatile unsigned int * T1CON = (volatile unsigned int *) ADDR_T1CON;
extern	volatile unsigned int * T2CNT = (volatile unsigned int *) ADDR_T2CNT;
extern	volatile unsigned int * T2CMP = (volatile unsigned int *) ADDR_T2CMP;
extern	volatile unsigned int * T2PER = (volatile unsigned int *) ADDR_T2PER;
extern	volatile unsigned int * T2CON = (volatile unsigned int *) ADDR_T2CON;
extern	volatile unsigned int * T3CNT = (volatile unsigned int *) ADDR_T3CNT;
extern	volatile unsigned int * T3CMP = (volatile unsigned int *) ADDR_T3CMP;
extern	volatile unsigned int * T3PER = (volatile unsigned int *) ADDR_T3PER;
extern	volatile unsigned int * T3CON = (volatile unsigned int *) ADDR_T3CON;
extern	volatile unsigned int * COMCON = (volatile unsigned int *) ADDR_COMCON;
extern	volatile unsigned int * ACTR = (volatile unsigned int *) ADDR_ACTR;
extern	volatile unsigned int * SACTR = (volatile unsigned int *) ADDR_SACTR;
extern	volatile unsigned int * DBTCON = (volatile unsigned int *) ADDR_DBTCON;
extern	volatile unsigned int * CMPR1 = (volatile unsigned int *) ADDR_CMPR1;
extern	volatile unsigned int * CMPR2 = (volatile unsigned int *) ADDR_CMPR2;
extern	volatile unsigned int * CMPR3 = (volatile unsigned int *) ADDR_CMPR3;
extern	volatile unsigned int * SCMPR1 = (volatile unsigned int *) ADDR_SCMPR1;
extern	volatile unsigned int * SCMPR2 = (volatile unsigned int *) ADDR_SCMPR2;
extern	volatile unsigned int * SCMPR3 = (volatile unsigned int *) ADDR_SCMPR3;
extern	volatile unsigned int * CAPCON = (volatile unsigned int *) ADDR_CAPCON;
extern	volatile unsigned int * CAPFIFO = (volatile unsigned int *) ADDR_CAPFIFO;
extern	volatile unsigned int * FIFO1 = (volatile unsigned int *) ADDR_FIFO1;
extern	volatile unsigned int * FIFO2 = (volatile unsigned int *) ADDR_FIFO2;
extern	volatile unsigned int * FIFO3 = (volatile unsigned int *) ADDR_FIFO3;
extern	volatile unsigned int * FIFO4 = (volatile unsigned int *) ADDR_FIFO4;
extern	volatile unsigned int * IMRA = (volatile unsigned int *) ADDR_IMRA;
extern	volatile unsigned int * IMRB = (volatile unsigned int *) ADDR_IMRB;
extern	volatile unsigned int * IMRC = (volatile unsigned int *) ADDR_IMRC;
extern	volatile unsigned int * IFRA = (volatile unsigned int *) ADDR_IFRA;
extern	volatile unsigned int * IFRB = (volatile unsigned int *) ADDR_IFRB;
extern	volatile unsigned int * IFRC = (volatile unsigned int *) ADDR_IFRC;
extern	volatile unsigned int * IVRA = (volatile unsigned int *) ADDR_IVRA;
extern	volatile unsigned int * IVRB = (volatile unsigned int *) ADDR_IVRB;
extern	volatile unsigned int * IVRC = (volatile unsigned int *) ADDR_IVRC;

#endif
















