/****************************************************************************
 **                                                                        **
 **                    # DSP TMS320F240 Using Header File #                **
 **                                                                        **
 ** .  TMS320F240 α׷ ϱ   Լ  ݴϴ.  **
 **                                                                        **
 **                                       - E.S.Lab., National Mokpo Univ. **
 **                                           - Homepage : www.eslab.or.kr **
 ****************************************************************************/


ioport unsigned port8011;
#define Led port8011

void PutLed(unsigned int Hexa)
{
	unsigned int Decimal=0;
	
	Decimal += Hexa % 10;
	Hexa /= 10;
	Decimal += (Hexa % 10)<<4;
	Hexa /= 10;
	Decimal += (Hexa % 10)<<8;
	Hexa /= 10;
	Decimal += (Hexa % 10)<<12;
	
	Led = Decimal;
	
}

/* Delay Լ : mSecs -   ð (:и )	*/
/*              20Mhz ӵ 					*/
void Delay(unsigned long mSecs)
{
	unsigned long count, endSecs;

	/* 0.001ʴ  1400 ̸  ð . */
	endSecs = mSecs * 700;	/* ð  */

	for(count=0; count<endSecs; count++)
	{
		asm("	nop");
	}
}

/* . void InitController() - TMS320F240 ʱȭ Ű Լ̴.	*/
/*																	*/
/* . Interrupts		- all maskable interrupts are disabled.			*/
/* . WatchDog Timer	- watchdog timer disabled.						*/
/* . PLL Module		- enabled.										*/
/* . Clocks			- CLKIN	 : 20Mhz (oscillator)					*/
/*					  CPUCLK : 20Mhz								*/
/*					  SYSCLK : 10Mhz								*/
/*					  WDCLK  : 15625Hz								*/
void InitController()
{
	/*  ͷƮ ߻  Ų. */
	DISABLE_ALL_INT();

	/* WatchDog Ÿ̸Ӹ  ʴ´. */
	DISABLE_WDT();

	/* Clock Control Register 1   Ѵ. */
	*CKCR1 = CKINF_20 |		/* CLKIN ԷµǴ Ŭ 20Mhz° ǥѴ.	*/
							/*   WDCLK ùٸ Ǹ Ŭ	*/
							/*  15625Hz Ǵ 16384Hz ̴.					*/
			 PLLDIV_1 |		/* CLKIN ޵Ǵ Ŭ ־ PLL Է	*/
							/* Ŭ Ѵ.								*/
			 PLLFB_RATIO_1;	/* CLKIN ޵Ǵ Ŭ Ͽ ø ʰ PLL	*/
							/*  Է Ŭ Ѵ.					*/

	/* Clock Control Register 0   Ѵ. */
	*CKCR0 = PLLPS_DIV_2 |	/* CPUCLK 2   SYSCLK Ѵ. 		*/
			 CLKMD_PLL;		/* CPUCLK PLL⿡  Ŭ Ѵٰ 	*/
							/* ϰ PLL ۵Ų.					*/

	/* PLL ùٸ ۽Ű   100us ð ɸ.	*/
	/*   α׷ ۵ų    ü	*/
	/* Ƿ PLL  ۵ɶ ٸ.				*/
	while(!IS_PLL_LOCKED()) ;
}